{{  MultiRxTxFlags110222a
  Modified from MultiRxTx110220b
  Program to test communication objects.
  The program both sends and receives information.
  This program uses the new 512 byte buffer four
  port serial driver.  The new driver uses flags
  to indicate a full transmission has been received.
  
}}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  '' Pin asignments
  _LargeBalancePinRx = 3        ' I connect this pin with _AnalyticalBalancePinTx (through 2k resistor)
  _LargeBalancePinTx = 2        ' I connect this pin with _SpectrometerPinRx (through 2k resistor) 
  _AnalyticalBalancePinRx = 1   ' I connect this pin with _SpectrometerPinTx (through 2k resistor)  
  _AnalyticalBalancePinTx = 0  
  _SpectrometerPinRx = 5
  _SpectrometerPinTx = 4
  
  _LedPin = 23
  
  _DebugBaud = 57600 '9600 4800 '   
  _AnalyticalBalanceBaud = 57600 '4800 4800 '
  _LargeBalanceBaud = 57600 '2400 4800 '
  _SpectrometerBaud = 57600 '1200 4800 '
 

  ' Com enumeration
  #0, _DebugCom, _AnalyticalBalanceCom, _LargeBalanceCom, _SpectrometerCom
   
VAR

  long rxFlag[4], oldRxFlag[4]
  byte endChar[4]

  
OBJ

  Com : "pcFullDuplexSerial4FC512Flags"
  led : "Flash"
  
PUB Main | count[8], localIndex, localCharacter

  waitcnt(clkfreq * 2 + cnt) 
  endChar[0] := 13
  endChar[1] := 13
  endChar[2] := 13
  endChar[3] := 13

  count[0] := Com.Init      
  count[1] := Com.AddPort(_DebugCom, 31, 30, -1, -1, 0, 0, _DebugBaud)
  count[2] := Com.AddPort(_AnalyticalBalanceCom, _AnalyticalBalancePinRx, _AnalyticalBalancePinTx, -1, -1, 0, 0, _AnalyticalBalanceBaud)
  count[3] := Com.AddPort(_LargeBalanceCom, _LargeBalancePinRx, _LargeBalancePinTx, -1, -1, 0, 0, _LargeBalanceBaud)
  count[4] := Com.AddPort(_SpectrometerCom, _SpectrometerPinRx, _SpectrometerPinTx, -1, -1, 0, 0, _SpectrometerBaud) 
  Com.SetFlags(endChar[0], endChar[1], endChar[2], endChar[3], @rxFlag[0])
  count[5] := Com.Start

  
  count[6] := led.Start(_LedPin, 250, 0)  ' "heart beat" LED

  ' Uncomment section in AddPort method to have buffer addresses returned.
  repeat localIndex from 0 to 6
    Com.str(_DebugCom, string(13, "count["))
    Com.dec(_DebugCom, localIndex)
    Com.str(_DebugCom, string("] = "))
    Com.dec(_DebugCom, count[localIndex])
  '
  localIndex := 0
  count[localIndex] := 0
  repeat
    
    count[0]++
    if count[0] // 4 == 0
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput1)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput2)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput3)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput4)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput5)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput6)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput7)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput8)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput9)
      Com.str(_AnalyticalBalanceCom, @analyticalBalanceOutput10)
      Com.str(_DebugCom, @analyticalBalanceOutput1)
    if count[0] // 4 == 1
      Com.str(_LargeBalanceCom, @largeBalanceOutput1)
      Com.str(_LargeBalanceCom, @largeBalanceOutput2)
      Com.str(_LargeBalanceCom, @largeBalanceOutput3)
      Com.str(_LargeBalanceCom, @largeBalanceOutput4)
      Com.str(_LargeBalanceCom, @largeBalanceOutput5)
      Com.str(_LargeBalanceCom, @largeBalanceOutput6)
      Com.str(_LargeBalanceCom, @largeBalanceOutput7)
      Com.str(_LargeBalanceCom, @largeBalanceOutput8)
      Com.str(_LargeBalanceCom, @largeBalanceOutput9)
      Com.str(_LargeBalanceCom, @largeBalanceOutput10) 
      Com.str(_DebugCom, @largeBalanceOutput1)
    if count[0] // 4 == 2
      Com.str(_SpectrometerCom, @spectrometerOutput1)
      Com.str(_SpectrometerCom, @spectrometerOutput2)
      Com.str(_SpectrometerCom, @spectrometerOutput3)
      Com.str(_SpectrometerCom, @spectrometerOutput4)
      Com.str(_SpectrometerCom, @spectrometerOutput5)
      Com.str(_SpectrometerCom, @spectrometerOutput6)
      Com.str(_SpectrometerCom, @spectrometerOutput7)
      Com.str(_SpectrometerCom, @spectrometerOutput8)
      Com.str(_SpectrometerCom, @spectrometerOutput9)
      Com.str(_SpectrometerCom, @spectrometerOutput10) 
      Com.str(_DebugCom, @spectrometerOutput1)
    repeat localIndex from _DebugCom to _SpectrometerCom
      Com.str(_DebugCom, string(13, "rxFlag["))
      Com.dec(_DebugCom, localIndex)
      Com.str(_DebugCom, string("] = "))
      Com.dec(_DebugCom, rxFlag[localIndex])
      repeat while rxFlag[localIndex] <> oldRxFlag[localIndex]
         
        repeat 
          localCharacter := Com.rxcheck(localIndex)
          if localCharacter => 0
            if (localCharacter > 31 and localCharacter < 127) or localCharacter == 13
              Com.tx(_DebugCom, localCharacter)
            else
              Com.tx(_DebugCom, "<")
              Com.ihex(_DebugCom, localCharacter, 2)
              Com.tx(_DebugCom, ">")
        while localCharacter <> endChar[localIndex]
        oldRxFlag[localIndex]++
    waitcnt(clkfreq/3 + cnt)
      
DAT                                  '         1         2         3         4         5
                                     '12345678901234567890123456789012345678901234567890123456789
analyticalBalanceOutput1        byte "Analytical, one, two, three, four, five, six", 13, 0 {45}
analyticalBalanceOutput2        byte "Analytical, seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
analyticalBalanceOutput3        byte "Analytical, thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
analyticalBalanceOutput4        byte "Analytical, seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
analyticalBalanceOutput5        byte "Analytical, twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
analyticalBalanceOutput6        byte "Analytical, twenty four, twenty five, twenty six", 13, 0 {49,294}
analyticalBalanceOutput7        byte "Analytical, twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
analyticalBalanceOutput8        byte "Analytical, thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
analyticalBalanceOutput9        byte "Analytical, thirty four, thirty five, thirty six", 13, 0 {49,452}
analyticalBalanceOutput10       byte "Analytical, thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
largeBalanceOutput1             byte "Large     , one, two, three, four, five, six", 13, 0 {45}
largeBalanceOutput2             byte "Large     , seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
largeBalanceOutput3             byte "Large     , thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
largeBalanceOutput4             byte "Large     , seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
largeBalanceOutput5             byte "Large     , twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
largeBalanceOutput6             byte "Large     , twenty four, twenty five, twenty six", 13, 0 {49,294}
largeBalanceOutput7             byte "Large     , twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
largeBalanceOutput8             byte "Large     , thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
largeBalanceOutput9             byte "Large     , thirty four, thirty five, thirty six", 13, 0 {49,452}
largeBalanceOutput10            byte "Large     , thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789                                                                                                   
spectrometerOutput1             byte "Spectro   , one, two, three, four, five, six", 13, 0 {45}
spectrometerOutput2             byte "Spectro   , seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
spectrometerOutput3             byte "Spectro   , thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
spectrometerOutput4             byte "Spectro   , seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
spectrometerOutput5             byte "Spectro   , twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
spectrometerOutput6             byte "Spectro   , twenty four, twenty five, twenty six", 13, 0 {49,294}
spectrometerOutput7             byte "Spectro   , twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
spectrometerOutput8             byte "Spectro   , thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
spectrometerOutput9             byte "Spectro   , thirty four, thirty five, thirty six", 13, 0 {49,452}
spectrometerOutput10            byte "Spectro   , thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789
                                            